.686
.model flat, stdcall
option casemap :none

      include c:\masm32\include\windows.inc
      include c:\masm32\include\kernel32.inc
      includelib c:\masm32\lib\kernel32.lib

.code
Start:
      mov   ebx, 2F2F2F2Fh                 ; 2Fh -> ASCII code of "/"
      sub   esp, 01E00h                    ; 1E00h=7680 bytes buffer
      db    3Eh                            ; nop
      xor   ebp, ebp                       ; ebp->counter of "/" addresses
      mov   esi, 0FEFEFEFFh
      call  GetCommandLine                 ; call API 
      mov   edx, [eax]                     ; eax->lpCmdLineBuffer
      lea   ecx, [ebp-4]                   ; ecx = -4
      db    3Eh                            ; nop
      mov   edi, eax                       ; edi-> lpCmdLineBuffer
BytesScan:                                 ; look for 1st "/" of the command line
      lea   eax, [esi+edx]                 ; searching "/"  and  zero
      xor   edx, ebx                       ; ebx= 2F2F2F2Fh ; 2Fh -> ASCII code of "/"
      add   edx, esi                       ; esi = 0FEFEFEFFh
      add   edi, 4                         ; edi-> lp next dword 
      or    eax, edx                       ; testing the "/" byte and 0 simultaneously
      mov   edx, [edi]                     ; edi->lpCmdLineBuffer
      test  eax, 80808080h
      je    BytesScan                      ; 4 clocks per 4 bytes
SrchTheByte:
      cmp   [edi+ecx], bl                  ; bl = 2Fh -> ASCII code of "/"
      je    SaveAddr                       ; found one "/" ; save the address
      cmp   byte ptr [edi+ecx], 0          ; is it the end of the command line string?
      je    ExitP                          ; yes, exit
ToNext:
      add   ecx, 1                         ; ecx-> from -4 until 0
      jne   SrchTheByte
      add   ecx, -4                        ; ecx = -4
      js    BytesScan                      ; loop again
SaveAddr:
      lea   eax, [edi+ecx]                 ; eax->the address of the current "/"
      add   ebp,1                          ; update the counter
      push  eax                            ; save it in the stack
      jne   ToNext                         ; loop again to check next byte
ExitP:
      test  ebp, ebp                       ; ebp->counter :  how many "/"
      je    PrintIt                        ; if eax = 0 -> exit with error
      add   edi, ecx                       ; edi->lp to last (zero) byte of the cmd line
      xor   ebx, ebx                       ; ebx->counter -> number of real params 
;..........................................;
ParamsLoop:
      mov   eax, [esp]                     ; eax->last saved "/" address from stack
      xor   edx, edx                       ; edx -> accumulates first 4 non empty bytes
SrchEnd:
      add   edi, -1                        ; dec edi
      cmp   eax, edi
      jg    NextParam
      cmp   byte ptr [edi], 21h
      jl    SrchEnd
      mov   [edi+1], dl                    ; edx=0
Find4BytesLoop:
      movzx ecx, byte ptr [eax]
      add   eax, 1
      cmp   eax, edi                       ; edi->address of current last byte at the cmd line
      jg    NextParam
      cmp   ecx, 21h                       ; if found SPACE or TAB, etc. skip this byte
      jl    Find4BytesLoop
      cmp   ecx, 2Fh                       ; 2Fh -> ASCII ->"/"
      je    Add2Register
      cmp   ecx, 3Ah                       ; 3Ah -> ASCII -> ":"
      je    Add2Register                   ; the key&option allows "/",":" and
      cmp   ecx, 41h                       ; latin letters ONLY
      jl    NextParam
      cmp   ecx, 5Bh
      jl    Convert2Lower
      cmp   ecx, 61h
      jl    NextParam
      cmp   ecx, 7Ah
      ja    NextParam
Add2Register:
      shl   edx, 8                         ; make room in register edx for the new byte
      add   edx, ecx
      test  edx, 0FF000000h                ; if the register edx has enough room loop again
      je    Find4BytesLoop                 ; else it has 1st four bytes of the key&option

;Compare the key and exec the prog if match

       mov  ecx, offset lpInputFile        ; ecx->offset lpInputFileName
       cmp  edx, 2F66693Ah                 ; /fi:  -> /=2Fh  f=66h i=69h  : =3Ah
       je   StripLeadSpaces
       add  ecx, 8                         ; ecx->offset lpOutputFileName
       cmp  edx, 2F666F3Ah                 ; /fo: -> /=2Fh  f=66h o=6Fh  : =3Ah
       je   StripLeadSpaces
       add  ecx, 8                         ; ecx->offset lpIdentifier
       cmp  edx, 2F69643Ah                 ; /id: -> /=2Fh  i=69h d=64h  : =3Ah
       jne  NextParam

StripLeadSpaces:
       cmp  byte ptr [eax], 21h
       jc   StripIt
       mov  [ecx], eax                     ; write begin address of the string in variable
       add  eax, -1
       add  ebx, 1                         ; ebx->counter -> number of real params
       sub  edi, eax
       mov  [ecx+4], edi                   ; write good flag -> length of the string  >0
       jno  NextParam
StripIt:
       add  eax, 1
       cmp  eax, edi
       jle  StripLeadSpaces

NextParam:                                 ; bottom of ParamsLoop:
       pop  edi                            ; edi->last saved "/" address from stack
       add  ebp,-1                         ; ebp->counter :  how many "/"
       jne  ParamsLoop                     ;    addresses are in the stack

;Check for enough parameters on the command line

CheckParams:
       mov  ebp, offset Tabl2A             ; Tabl2A ->  Err7  "invalid  parameters"
       add  ebx, -3                        ; ebx->counter -> number of real params
       jne  PrintIt                        ; if eax = 0 -> exit with error
       add  ebp, 12                        ; Tabl3 Error code "Input file not found"
       jne  OpenFiles                      ; all is OK continue with files
Convert2Lower:
       or   ecx, 20h                       ; to lowercase
       jne  Add2Register

; Write notification messages on the screen

PrintIt:
       mov  edi, offset Tabl1              ; Tabl1 -> Print logo with help only
       mov  ebx, esp                       ; buffer for notification messages
       test ebp, ebp                       ; ebp -> flag and address of error message
       mov  esi, ebx                       ; buffer for notification messages
       je   DLoop2                         ; start it
       add  edi, 20                        ; Tabl2 -> Print logo with help plus error message
       jne  DLoop2                         ; start it 

OpenFiles:
; Open Input file for reading

       push  ebx                           ; ebx =0
       mov   eax, lpInputFile
       push  FILE_ATTRIBUTE_ARCHIVE
       push  OPEN_EXISTING
       push  ebx                           ; ebx = 0
       push  ebx
       push  GENERIC_READ
       push  eax                           ; eax-> lpInputFile
       call  CreateFile
       cmp   eax, INVALID_HANDLE_VALUE     ; INVALID_HANDLE_VALUE = -1
       je    PrintIt                       ; Error code "Input file not found"
       mov   hFileInput, eax

; Get file size of Input file 

       add   ebp, 12                       ; Tabl4-> Err2  "invalid input file"
       push  ebx                           ; ebx =0
       push  eax                           ; eax-> hFileInput
       call  GetFileSize
       test  eax, eax 
       je    PrintIt                       ; Error exit with "Invalid input file"
       mov   ebx, eax                      ; ebx-> file size of Input file

; Allocate memory for output buffer

       mov   eax, lenIdentifier
       mov   edi, 16h                      ; edi-> size of the identifier's  part
       add   ebp, 12                       ; Tabl5 -> Err3  "no memory"
       cmp   eax, 9
       jl    Allo1
       lea   edi, [eax+17h]                ; edi-> new size of the identifier's part
Allo1:
       mov   eax, esp                      ; eax -> lp output buffer
       lea   edi, [edi+ebx+3Ch]            ; edi-> size of the output file
       cmp   edi, 2000h                    ; If the input file is big we'll use the standard API
       jle   NoAllocMem                    ;  else we use the stack
       push  edi                           ; edi-> size of the output file
       push  GMEM_FIXED
       call  GlobalAlloc                   ; call API
       test  eax, eax 
       je    PrintIt                       ; Error code "no memory"
       mov   hMem, eax
NoAllocMem:
       mov   ecx, hFileInput
       mov   esi, eax                      ; esi = eax -> lp output buffer

; Read input file in the output buffer
 
       push  0
       add   eax, 3Ch                      ; we'll read  at offset 3Ch of output buffer
       push  offset  nWritenBytes
       add   ebp, 12                       ; Tabl6 -> Err5  "can't read input file"
       push  ebx                           ; ebx-> size of Input file
       push  eax                           ; eax -> lp output buffer
       push  ecx                           ; ecx -> hFileInput
       call  ReadFile
       cmp   ebx, nWritenBytes             ; ebx-> file size of Input file
       jne   PrintIt                       ; Error code "Can't read input file"

; Create Output file for writing

        mov  eax, lpOutputFile
        xor  ecx, ecx
        push ecx
        add  ebp, 12                       ; Tabl7 -> Err4  "can't create output file"
        push FILE_ATTRIBUTE_ARCHIVE
        push CREATE_ALWAYS
        push ecx
        push ecx
        push GENERIC_WRITE
        push eax                           ; eax - > lpOutputFile
        call CreateFile
        cmp  eax, INVALID_HANDLE_VALUE     ; INVALID_HANDLE_VALUE = -1
        je   PrintIt                       ; Error code "Can't create output file." 
        mov  hFileOutput, eax
        xor  ecx, ecx                      ; ecx=0
        push ecx                           ; push -> 5 parameters for  WriteFile API
        push offset nWritenBytes
        push edi                           ; edi-> how many bytes to write
        push esi                           ; esi-> lp output buffer
        push eax                           ; eax->hFileOutput

; Write header in output buffer

        lea  edx, [ebx+3Ch]                ; ebx-> file size of Input file
        mov  dword ptr [esi], 01014Ch
        mov  [esi+4], ecx                  ; ecx = 0
        mov  [esi+8], edx                  ; begin identifier
        mov  dword ptr [esi+12], 1
        mov  dword ptr [esi+16], 050000h 
        mov  dword ptr [esi+20], 7461642Eh ; ASCII-> ".data"
        mov  dword ptr [esi+24], 61h
        mov  [esi+28], ecx 
        mov  [esi+32], ecx                 ; ecx=0
        mov  [esi+36], ebx
        mov  dword ptr [esi+40], 3Ch       ; begin offset 
        mov  [esi+44], ecx
        mov  [esi+48], ecx 
        mov  [esi+52], ecx                 ; ecx=0
        mov  dword ptr [esi+56], 40h
        lea  eax, [esi+ebx+3Ch]            ; esi->offset in the output buffer

; Write the identifier string  in the output buffer
 
        mov  edx , lpIdentifier
        mov  ebx, lenIdentifier
        cmp  ebx, 9
        mov  [eax], ecx                    ; ecx=0
        mov  [eax+4], ecx
        mov  [eax+8], ecx
        mov  dword ptr [eax+12], 1
        mov  dword ptr [eax+16], 2
        mov  [eax+20], ecx                 ; ecx=0
        jl   CopyLoop
        mov  [eax+ebx+22], cl              ; ecx =0
        add  ecx, 4
        mov  [eax+4], ecx                  ; ecx =4
        lea  ecx, [ebx+5]                  ; ebx-> file size of Input file
        mov  [eax+18], ecx                 ; ecx=ebx+5
        add  eax, 22
CopyLoop:
        mov  cl, [edx+ebx-1]               ; copy Id string
        add  ebx, -1
        mov  [eax+ebx], cl
        jne  CopyLoop

; Write the output buffer to the output file

        add  ebp, 12                       ; Tabl8 -> Err6  "disk full"
        call WriteFile                     ; call API
        cmp  edi, nWritenBytes             ; edi->requested bytes
        jne  PrintIt                       ; else error exit
 ExitProg:
        mov  eax, hFileInput
        mov  ebx, hMem
        mov  edi, hFileOutput
        mov  esi, offset CloseHandle       ; esi-> lp CloseHandle API
        push eax                           ; eax -> hFileInput
        call esi                           ; esi-> lp CloseHandle API
        push edi                           ; edi-> hFileOutput
        call esi                           ; esi-> lp CloseHandle API
        test ebx, ebx                      ; ebx -> hMem
        je   ExitProcess
        push ebx                           ; ebx-> hMem
        push offset ExitProcess            ; call API to kill the process
        jne   GlobalFree                   ; call API to free memory

; From PrintIt
DLoop1:
        mov  dl, [eax+ecx]
        add  ecx, 1
        mov  [ebx+ecx-1], dl
        jne  DLoop1
DLoop2: 
        mov  ecx, [edi]                    ; ecx=length
        add  edi, 8
        mov  eax, [edi-4]                  ; eax->address
        sub  ebx, ecx
        jc   DLoop1
        test ebp, ebp                      ; ebp -> flag and address of error message
        mov  edi, ebp                      ; edi -> address of error message
        mov  ebp, ecx                      ; ecx = 0
        jne  DLoop2
        push STD_OUTPUT_HANDLE
        call GetStdHandle                  ; ecx -> API address
        push ebp                           ; ebp =0
        sub  ebx, esi                      ; ebx-> size of message
        push offset nWritenBytes
        mov  ecx, offset WriteFile         ; ecx -> API address
        push ebx                           ; ebx-> size of message
        push esi                           ; esi -> lp buffer (in the stack)
        push eax                           ; eax -> hFile
        push offset ExitProg               ; return address
        jmp  ecx                           ; call WriteFile API

; Data
Align 4
        lpInputFile   dd 0                 ; lp of input file name string
        lenInputFile  dd 0                 ; len of input file name string
        lpOutputFile  dd 0                 ; lp of output file name string
        lenOutputFile dd 0                 ; len of output file name string
        lpIdentifier  dd 0                 ; lp Identifier string
        lenIdentifier dd 0                 ; len of Identifier string
        hFileInput    dd 0 
        hFileOutput   dd 0
        hMem          dd 0
        nWritenBytes  dd 0

; Length(negative) Address+length(positive)
Tabl1   dd -160, 400040h+160               ; no parameters ; print logo and help only
        dd -72, offset Mess1+72, 0
Tabl2   dd -160, 400040h+160               ; print logo and help  with error message
        dd -72, offset Mess1+72 
        dd -7,  400040h+7
        dd -16,offset Error+16, 0
Tabl2A  dd -33, offset Err7+33, 0          ; Err7  "invalid  parameters"
Tabl3   dd -22, offset Err1+22, 0          ; Err1  "input file not found" 
Tabl4   dd -20, offset Err2+20, 0          ; Err2  "invalid input file"
Tabl5   dd -11, offset Err3+11, 0          ; Err3  "no memory"
Tabl6   dd -21, offset Err5+21, 0          ; Err5  "can't read input file"
Tabl7   dd -26, offset Err4+26, 0          ; Err4  "can't create output file"
Tabl8   dd -11, offset Err6+11, 0          ; Err6  "disk full"

Mess1   db " output obj file in coff format", 0Dh, 0Ah,9
        db "/id:identifier - identifier to use", 0Dh, 0Ah, 0Dh, 0Ah
Error   db " : fatal error: "
Err1    db "input file not found", 0Dh, 0Ah
Err2    db "invalid input file", 0Dh, 0Ah
Err3    db "no memory", 0Dh, 0Ah
Err4    db "can't create output file", 0Dh, 0Ah
Err5    db "can't read input file", 0Dh, 0Ah
Err6    db "disk full", 0Dh, 0Ah
Err7    db "invalid command line parameters", 0Dh, 0Ah

End     Start


;makeit.bat

;\masm32\bin\ml  /c /coff %1.asm
;\masm32\bin\LinkP.exe  /SUBSYSTEM:CONSOLE /STUB:stub.exe /MERGE:.rdata=.text /SECTION:.text, CEWR %1.obj

;Note:  LinkP.exe is patched MS Linker - see my post here:
;http://board.win32asmcommunity.net/showthread.php?s=53eb54f2ec806d84f8127b01929c5e52&threadid=;14699&highlight=Lingo


